{% extends "ajax/ajax_plain.html.twig" %}
{% block ajax_base %}
    {% macro icon_master(post) %}
        {% set user = post.owner %}
        {% if post.type != "USER" or post.thread.forum.town is null %}
            {% if user|is_granted('ROLE_SUPER') %}
                <div class="inline-block mh-icon">
                    <img alt="ADM" src="{{ asset('build/images/icons/icon_mh_admin.gif') }}" />
                    <div class="tooltip">{{ 'Dieser Spieler ist ein Administrator auf diesem Server.'|trans({},'global') }}</div>
                </div>
            {% elseif user|is_granted('ROLE_ADMIN') %}
                <div class="inline-block mh-icon">
                    <img alt="ADM" src="{{ asset('build/images/icons/icon_mh_admin.gif') }}" />
                    <div class="tooltip">{{ 'Dieser Spieler ist ein Entwickler von MyHordes.'|trans({},'global') }}</div>
                </div>
            {% elseif user|is_granted('ROLE_CROW') %}
                <div class="inline-block mh-icon">
                    <img alt="MOD" src="{{ asset('build/images/icons/icon_mh_mod.gif') }}" />
                    <div class="tooltip">{{ 'Dieser Spieler ist ein Moderator auf MyHordes.'|trans({},'global') }}</div>
                </div>
            {% elseif user|is_granted('ROLE_ANIMAC') %}
                <div class="inline-block mh-icon">
                    <img alt="ANIM" src="{{ asset('build/images/icons/icon_mh_anim.gif') }}" />
                    <div class="tooltip">{{ 'Dieser Spieler ist ein Animateur auf MyHordes.'|trans({},'global') }}</div>
                </div>
            {% elseif user|is_granted('ROLE_ORACLE') %}
                <div class="inline-block mh-icon">
                    <img alt="ORAC" src="{{ asset('build/images/icons/icon_mh_orac.gif') }}" />
                    <div class="tooltip">{{ 'Dieser Spieler ist ein Orakel auf MyHordes.'|trans({},'global') }}</div>
                </div>
            {% elseif user|is_granted('ROLE_TEAM') %}
                <div class="inline-block mh-icon">
                    <img alt="MH" src="{{ asset('build/images/icons/icon_mh_team.gif') }}" />
                    <div class="tooltip">{{ 'Dieser Spieler ist Mitglied des Entwickler-Teams von MyHordes.'|trans({},'global') }}</div>
                </div>
            {% endif %}
        {% endif %}
    {% endmacro %}

    {# @var posts \App\Entity\Post[] #}
    {# @var permission \App\Structures\ForumPermissionAccessor #}
    {% set first_buttons = true %}
    {% block buttons %}
        <div class="{% if first_buttons %}forum-control{% endif %}">
            {% if first_buttons %}<div class="forum-header-bar"><i class="fa fa-comments"></i> {{ title }}</div>{% endif %}
            <div class="row-flex wrap stretch">
                <div class="cell padded grow-1 left">
                    {% if permission.moderate() %}
                        <div tabindex="0" class="forum-button button-dropdown-button" style="padding: 4px;">
                            <img alt="" src="{{ asset('build/images/icons/mod.png') }}" />
                            <div class="button-dropdown">
                                {% if not locked %}
                                    <div tabindex="0" x-forum-moderator-action="lock" class="forum-button">
                                        <img alt="" src="{{ asset('build/images/icons/mod.png') }}" />
                                        <span>{{ 'Schließen'|trans({},'global') }}</span>
                                    </div>
                                    <div tabindex="0" x-forum-moderator-action="solve" class="forum-button">
                                        <img alt="" src="{{ asset('build/images/icons/mod.png') }}" />
                                        <span>{{ 'Gelöst'|trans({},'global') }}</span>
                                    </div>
                                {% endif %}
                                {% if locked %}
                                    <div tabindex="0" x-forum-moderator-action="unlock" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'unlock'}) }}" class="forum-button">
                                        <img alt="" src="{{ asset('build/images/icons/mod.png') }}" />
                                        <span>{{ 'Öffnen'|trans({},'global') }}</span>
                                    </div>
                                {% endif %}
                                {% if not pinned %}
                                    <div tabindex="0" x-forum-moderator-action="pin" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'pin'}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/icons/mod.png') }}" /><span>{{ 'Anpinnen'|trans({},'global') }}</span></div>
                                {% else %}
                                    <div tabindex="0" x-forum-moderator-action="unpin" x-forum-api-endpoint="{{ url('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'unpin'}) }}" class="forum-button"><img alt="" src="{{ asset('build/images/icons/mod.png') }}" /><span>{{ 'Loslösen'|trans({},'global') }}</span></div>
                                {% endif %}
                                {% if thread_moveable_forums is not empty and not thread.translatable %}
                                    <div tabindex="0" x-forum-moderator-action="move" class="forum-button"><img alt="" src="{{ asset('build/images/icons/mod.png') }}" /><span>{{ 'Thread verschieben'|trans({},'global') }}</span></div>
                                {% endif %}
                            </div>
                        </div>
                    {% endif %}
                    {% if permission.help() and not locked %}
                        <div tabindex="0" class="forum-button button-dropdown-button" style="padding: 4px;">
                            <img alt="" src="{{ asset('build/images/icons/icon_mh_orac.gif') }}" />
                            <div class="button-dropdown">
                                {% if not locked %}
                                    <div tabindex="0" x-forum-moderator-action="solve" class="forum-button">
                                        <img alt="" src="{{ asset('build/images/icons/icon_mh_orac.gif') }}" />
                                        <span>{{ 'Gelöst'|trans({},'global') }}</span>
                                    </div>
                                {% endif %}
                            </div>
                        </div>
                    {% endif %}
                </div>
                <div class="cell padded grow-1 right">
                    <div x-forum-action="{{ subscribed ? 'unsub' : 'sub' }}" class="forum-button">
                        {% if subscribed %}
                            <img alt="" src="{{ asset('build/images/icons/tickOn.gif') }}" />
                        {% else %}
                            <img alt="" src="{{ asset('build/images/icons/tickOff.gif') }}" />
                        {% endif %}
                        <span>{{ subscribed ? 'Abonniert'|trans({},'global') : 'Abonnieren'|trans({},'global') }}</span>
                        <div class="tooltip forum-tooltip">{{ subscribed ? 'Du wirst nicht mehr informiert, wenn es neue Beiträge zu dieser Diskussion gibt.'|trans({},'global') : 'Du wirst informiert, wenn es neue Beiträge zu dieser Diskussion gibt'|trans({}, 'global')}}</div>
                    </div>

                    {% if not locked and not app.user|restricted(constant('App\\Entity\\AccountRestriction::RestrictionForum')) and (permission.create_post or permission.moderate) %}
                        <div x-forum-action="answer" class="forum-button"><span>{{ 'Antworten'|trans({},'global') }}</span></div>
                    {% else %}
                        <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/lock.gif') }}" /><span>{{ 'Antworten'|trans({},'global') }}</span></div>
                    {% endif %}
                </div>
            </div>
        </div>
        {% if first_buttons %}<br />{% endif %}
        <div class="row">
            <div class="cell padded rw-8 ro-2">
                <div class="{% if locked and not solved %}infoThread{% endif %} {% if locked and solved %}infoSolvedThread{% endif %}">
                    {% if locked and not solved %}
                        {{ 'Diese Diskussion ist beendet.'|trans({},'global') }}
                    {% endif %}
                    {% if locked and solved %}
                        {{ 'Diese Diskussion ist als gelöst markiert (oder der Anlass hat sich mittlerweile erledigt).'|trans({},'global') }}
                    {% endif %}
                </div>
            </div>
        </div>
    {% endblock %}
    {% set first_buttons = false %}
    {% macro pagenav(pages,current_page,id) %}
        {% if pages > 1 %}
            <div class="row">
                <div id="pagenav-{{ id }}" class="cell rw-12 padded center">
                    {% if current_page > 1 %}
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="1"><img alt="" src="{{ asset('build/images/icons/small_prev.gif') }}" /></div>
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="{{ current_page - 1 }}"><img alt="" src="{{ asset('build/images/icons/small_moveleft.gif') }}" /></div>
                    {% else %}
                        <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_prev.gif') }}" /></div>
                        <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_moveleft.gif') }}" /></div>
                    {% endif %}
                    <div class="forum-button" x-forum-action="post-select-page">
                        {{ 'Seite {page}/{pages}'|trans({'{page}': '<span class="current_page_marker">&nbsp;' ~ current_page ~ '</span>', '{pages}': pages},'global')|raw }}
                        <div class="tooltip">
                            {{ 'Zum Wechsein der Seite hier klicken'|trans({}, 'global') }}
                        </div>
                    </div>
                    {% if current_page < pages %}
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="{{ current_page + 1 }}"><img alt="" src="{{ asset('build/images/icons/small_move.gif') }}" /></div>
                        <div class="forum-button" x-forum-action="post-pager" x-to-page="{{ pages }}"><img alt="" src="{{ asset('build/images/icons/small_next.gif') }}" /></div>
                    {% else %}
                        <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_move.gif') }}" /></div>
                        <div class="forum-button-disabled"><img alt="" src="{{ asset('build/images/icons/small_next.gif') }}" /></div>
                    {% endif %}
                </div>
            </div>
        {% endif %}
    {% endmacro %}
    {{ _self.pagenav(pages,current_page,'top') }}

    {% if permission.moderate and announces.reported|length > 0 %}
        <div class="row">
            <div class="cell padded rw-8 ro-2">
                <div class="reported announces">
                    <span class="announce">{{'Dieses Thema enthält {count} gemeldete Posts:'|trans({"{count}": announces.reported|length}, 'global')}}</span>
                    <ul>
                        {% for reported in announces.reported %}
                            <li x-ajax-target="#content" x-ajax-href="{{path('forum_jump_view', {pid: reported.id})}}">[{{reported.date|format_datetime('medium', 'none')}}] {{reported.text|striptags|slice(0, 50)}}[...]</li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
    {% endif %}

    {% if announces.admin|length > 0 %}
        <div class="row">
            <div class="cell padded rw-8 ro-2">
                <div class="adminAnnounces announces">
                    <span class="announce">{{'Dieses Thema enthält {count} offizielle Ansage(n) der MyHordes-Administratoren:'|trans({"{count}": announces.admin|length}, 'global')}}</span>
                    <ul>
                        {% for adminannounce in announces.admin %}
                            <li x-ajax-target="#content" x-ajax-href="{{path('forum_jump_view', {pid: adminannounce.id})}}">[{{adminannounce.date|format_datetime('medium', 'none')}}] {{adminannounce.text|striptags|slice(0, 50)}}[...]</li>
                        {% endfor %}
                    </ul>
                </div>
            </div>
        </div>
    {% endif %}

    {% if announces.oracle|length > 0 %}
        <div class="row">
            <div class="row">
                <div class="cell padded rw-8 ro-2">
                    <div class="oracleAnnounces announces">
                        <span class="announce">{{'Dieses Thema enthält {count} Ansage(n) von Community-Vertretern:'|trans({"{count}": announces.oracle|length}, 'global')}}</span>
                        <ul>
                            {% for oracleannounce in announces.oracle %}
                                <li x-ajax-target="#content" x-ajax-href="{{path('forum_jump_view', {pid: oracleannounce.id})}}">[{{oracleannounce.date|format_datetime('medium', 'none')}}] {{oracleannounce.text|striptags|slice(0, 50)}}[...]</li>
                            {% endfor %}
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    {% endif %}

    <div class="forum-posts">
        {% for post in posts %}
            {% set variant = null %}
            {% if post.owner.name == 'Der Rabe' %}{% set variant = 'crow' %}
            {% elseif post.type != "USER" and post.type is not null %}{% set variant = post.type|lower %}{% endif %}

            {# @var post \App\Entity\Post #}
            {% if not post.hidden or permission.moderate() %}
                <div x-post-wrapper-id="{{ post.id }}" class="forum-post {% if variant is not null %}forum-post-variant-{{ variant }}{% endif %} {% if not post.hidden %}{% else %}forum-post-hidden{% endif %} {% if post.new %}forum-post-new{% endif %} {% if markedPost is defined and post.id == markedPost %}forum-post-marked{% endif %}">
                    <div class="forum-post-header {% if variant is not null %}header-variant-{{ variant }}{% endif %}">
                        <i>
                            {% if post.date >= 'today'|to_date %}
                                {{ 'Heute um'|trans({},'global') }} {{ post.date|format_datetime('none', 'short') }}
                            {% elseif post.date >= 'yesterday'|to_date %}
                                {{ 'Gestern um'|trans({},'global') }} {{ post.date|format_datetime('none', 'short') }}
                            {% else %}
                                {{ post.date|format_datetime('medium', 'short') }}
                            {% endif %}
                        </i>
                        {% if post.owner.name == 'Der Rabe' %}
                            {% if app.user.preferSmallAvatars %}
                                <div class="avatarcrow small"><img alt="" src="{{ asset('build/images/forum/crow/crow.small.' ~ (app.request.locale|e('html_attr')|split('_', 2))[0] ~ '.png') }}"></div>
                            {% else %}
                                <div class="avatarcrow"><img alt="" src="{{ asset('build/images/forum/crow/crow.' ~ (app.request.locale|e('html_attr')|split('_', 2))[0] ~ '.png') }}"></div>
                            {% endif %}
                        {% elseif (post.owner.avatar) %}
                            {% if app.user.preferSmallAvatars %}
                                <div class="avatar small ua-{{random(0,9)}}"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.smallName, 'ext': post.owner.avatar.format}) }}"></div>
                            {% else %}
                                <div class="avatar ua-{{random(0,9)}}"><img alt="" src="{{ path('app_web_avatar', {'uid': post.owner.id, 'name': post.owner.avatar.filename, 'ext': post.owner.avatar.format}) }}"></div>
                            {% endif %}
                        {% else %}
                            <div class="avatar small"><img alt="" src="{{ asset('build/images/forum/empty_avatar.gif') }}"></div>
                        {% endif %}
                        {% include 'ajax/soul/playername.html.twig' with {user: post.owner, globalSpace: post.thread.forum.town is null} only %}{{ post.translate ? ('') : (_self.icon_master(post))}}<br />
                        {% if post.owner.name == 'Der Rabe' %}
                            <span class="small"><i>{{ 'Ich beobachte euch...'|trans({},'game') }}</i></span>
                        {% elseif post.owner.activeTitle or post.owner.activeIcon %}
                            <span class="small">
                                {% if post.owner.activeIcon %}<img alt="" src="{{ post.owner.activeIcon.customIcon ? url('app_web_customicon', {uid: post.owner.id, aid: post.owner.activeIcon.id, name: post.owner.activeIcon.customIconName, ext: post.owner.activeIcon.customIconFormat}) : asset('build/images/icons/title/' ~ post.owner.activeIcon.prototype.icon ~ '.gif') }}" />{% endif %}
                                {% if post.owner.activeTitle %}<i>{{ post.owner.activeTitle.customTitle ?? post.owner.activeTitle.prototype.title|trans({},'game')|raw }}</i>{% endif %}
                            </span>
                        {% endif %}
                        {% if post.note is not null %}<div class="float-right post-note">{{ post.note|replace({'{at_00}': '<span class="hide-sm">' ~ 'in der Stadt oder am Stadttor'|trans({},'game') ~ '</span><span class="hide-md hide-lg hide-desktop">[0, 0]</span>' })|raw }}</div>{% endif %}
                    </div>
                    {% if permission.moderate() %}
                        {% if post.adminReports(true)|length > 0 %}
                            <div class="modrev modWarnText pointer">
                                <span>{{ '{num} Meldungen. Klicken, um Benutzer anzuzeigen.'|trans({'{num}': post.adminReports(true)|length},'global') }}</span>
                                <div>
                                    {% set complaint_list = [
                                        'Keinen Grund angeben','Cheating','Flooding oder Spam','Verwendung einer anderen als der Forensprache',
                                        'Beleidigungen / Unangemessener Ausdruck','Pornographie','Hassrede','Verbreitung persönlicher Informationen',
                                        'Verletzung von Copyright','Aufruf zu Gesetzesverstößen','Ermutigung von Selbstmord oder Selbstverletzung'
                                    ] %}
                                    {% for report in post.adminReports(true) %}
                                        <div>
                                            <a target="_blank" href="{{ path('soul_visit', {id: report.sourceUser.id}) }}">{{ report.sourceUser.name }}</a>:
                                            {% if report.reason > 0 and report.reason < complaint_list|length %}
                                                <i>{{ complaint_list[report.reason]|trans({},'global') }}</i>
                                            {% endif %}
                                            {% if report.details is not null %}
                                                <div class="tooltip"><div class="bold">{{ 'Details'|trans({},'global') }}</div><p>{{ report.details }}</p></div>
                                            {% endif %}
                                        </div>
                                    {% endfor %}
                                </div>
                            </div>
                        {% endif %}
                        {% if post.originalText is not null %}
                            <div class="modrev modOrigText pointer">
                                <span>{{ 'Ursprünglichen Text anzeigen'|trans({},'global') }}</span>
                                <div>{{ post.originalText|raw }}</div>
                            </div>
                        {% endif %}
                        {% if post.adminDeletion is not null %}
                            <div class="modrev modInfoText pointer">
                            <span>{{ 'Gelöscht von {user} ({time}). Klicken, um den Grund einzublenden.'|trans({
                                    '{user}': post.adminDeletion.sourceUser.name,
                                    '{time}': post.adminDeletion.timestamp|format_datetime('medium', 'short'),
                                },'global') }}</span>
                                <div>{{ post.adminDeletion.reason }}</div>
                            </div>
                        {% endif %}
                    {% endif %}


                    <div class="forum-post-content" x-post-content-id="{{ post.id }}" x-post-content-author-id="{{ post.owner.id }}" x-post-content-author="{% include 'ajax/soul/playername.html.twig' with {user: post.owner, plain: true, globalSpace: post.thread.forum.town is null} only %}">
                        {{ post.translate ? (post.text|trans({},'game')|raw) : (post.text|raw) }}
                        {% if not post.translate and paranoid and post.owner.name != 'Der Rabe' %}
                            {% set mode = (app.user.id + post.id + post.owner.id) % 12 %}
                            {% if mode == 0 %}
                                <br/>{{ 'Hängt {user}!'|trans({'{user}': app.user.activeCitizen.alias ?? app.user.name},'game') }}
                            {% elseif mode == 1 %}
                                <br/>{{ '{user} wir kriegen dich!'|trans({'{user}': app.user.activeCitizen.alias ?? app.user.name},'game') }}
                            {% endif %}
                        {% endif %}
                    </div>
                    <div class="forum-post-footer">
                        <div class="float-left small">
                            {% if not permission.own() %}
                                {% if post.edited is not null and post.lastAdminActionBy is null %}
                                    {{ 'Zuletzt bearbeitet: {date}'|trans({'{date}': post.edited|format_datetime('medium', 'short')},'game') }}
                                {% elseif post.edited is not null and post.lastAdminActionBy is not null %}
                                    {{ 'Von einem Moderator bearbeitet.'|trans({},'game') }}
                                {% endif %}
                            {% else %}
                                {% if post.edited is not null and post.lastAdminActionBy is null %}
                                    {{ 'Zuletzt bearbeitet: {date}'|trans({'{date}': post.edited|format_datetime('medium', 'short')},'game') }}
                                {% elseif post.lastAdminActionBy is not null and post.edited is not null %}
                                    {{ 'Zuletzt bearbeitet: {date}'|trans({'{date}': post.edited|format_datetime('medium', 'short')},'game') }}
                                    {{ ' ~ MOD: ' ~ post.lastAdminActionBy.name }}
                                {% elseif post.lastAdminActionBy is not null and post.edited is null %}
                                    {{ 'MOD: ' ~ post.lastAdminActionBy.name }}
                                {% endif %}
                            {% endif %}
                        </div>
                        <div class="float-right">
                            {% if permission.moderate() %}
                                <label class="mod-submenu" for="mod-submenu-toggle-{{ post.id }}">
                                    <input type="checkbox" name="mod-submenu-toggle-{{ post.id }}" id="mod-submenu-toggle-{{ post.id }}" />
                                    <ul class="mod-submenu-links">
                                        {% if post.adminReports(true)|length > 0 %}
                                            <li><a class="action-button" x-forum-moderator-action="seen" x-post-id={{ post.id }} x-to-page={{ current_page }}>{{ 'Überprüft'|trans({},'global') }}</a></li>
                                        {% endif %}
                                        {% if post.hidden %}
                                            <li><a class="action-button" x-forum-moderator-action="undelete-post" x-post-id={{ post.id }} x-to-page={{ current_page }}>{{ 'Wiederherstellen'|trans({},'global') }}</a></li>
                                        {% else %}
                                            <li><a class="action-button" x-forum-moderator-action="delete-post" x-post-id={{ post.id }} x-to-page={{ current_page }}>{{ 'Löschen'|trans({},'global') }}</a></li>
                                            <li><a class="action-button" x-forum-moderator-action="edit-post"   x-post-id={{ post.id }} x-to-page={{ current_page }}>{{ 'Bearbeiten'|trans({},'global') }}</a></li>
                                        {% endif %}
                                    </ul>
                                </label>
                            {% endif %}
                            {% if not locked %}
                                {% if (post.owner == app.user or (post.owner.id == 66 and permission.post_as_crow()) or (post.owner.id == 67 and permission.post_as_animacteur())) and post.editable and (post == thread.firstPost(true) or post == thread.lastPost(false)) %}
                                    [ <a class="action-button" id="edit_post"  x-forum-action="edit-post"  x-post-id={{ post.id }} ><img alt="" src="{{ asset('build/images/forum/edit.png') }}"><div class="tooltip forum-tooltip">{{'Bearbeiten'|trans({}, 'global')}}</div></a> ]
                                {% endif %}
                            {% endif %}
                            [ <a class="action-button" id="link_post" x-forum-action="link-post" x-post-id={{ post.id }}>{{ 'Link'|trans({},'global') }}</a> ]
                            {% if not locked %}
                                [ <a class="action-button" id="copy_post" x-forum-action="copy-post" x-post-id={{ post.id }} >{{ 'Kopieren'|trans({},'global') }}</a> ]
                                [ <a class="action-button" id="quote_post" x-forum-action="quote-post" x-post-id={{ post.id }} >{{ 'Zitieren'|trans({},'global') }}</a> ]
                            {% endif %}
                            {% if not post.translate and app.user != post.owner and not permission.only_mod_access %}
                                [ <a class="action-button" id="report_post" x-forum-action="report-post" x-post-id={{ post.id }} x-to-page={{ current_page }}><img alt="!" src="{{ asset('build/images/forum/warning.png') }}"><div class="tooltip forum-tooltip">{{'Unangemessene Nachricht blockieren'|trans({}, 'global')}}</div></a> ]
                            {% endif %}
                            <div class="small hidden" id="link-post-{{ post.id }}">
                                <div class="float-left"><i>{{ 'Permanenter Link zu diesem Post:'|trans({},'global') }}</i></div>
                                <div class="float-right">{{ url('forum_jump_view', {pid: post.id}) }}</div>
                            </div>
                        </div>
                    </div>
                </div>
            {% endif %}
        {% endfor %}
    </div>
    {{ block('buttons') }}
    {{ _self.pagenav(pages,current_page,'bottom') }}
{% endblock %}
{% block js %}
    {{ parent() }}
    {{ include('ajax/flash.html.twig') }}
    <script>
        const loadPage = function(page) {
            $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page: page } );
        };
        const reloadPage = function() { loadPage( {{ current_page }} ); };
        const reloadForum = function() { $.ajax.no_history().load( null, '{{ url('forum_view', {id: fid}) }}', false ); }
        const reloadForumKeepPage = function() {
            const page = parseInt( document.querySelector('[data-thread-current-page]')?.dataset?.threadCurrentPage ?? 0 );
            $.ajax.no_history().load( null, '{{ url('forum_view', {id: fid}) }}', false, { page } );
        }

        {% if permission.moderate %}
            $.html.addEventListenerAll('[x-forum-moderator-action="lock"]', 'click', function(e,elem) {
                let reason = prompt('{{ 'Grund'|trans({},'admin')|e('js') }}', '');
                if (reason !== null)
                    $.ajax.easySend('{{ path('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'lock'}) }}', {reason}, reloadPage);
            });
        {% endif %}
        {% if permission.help or permission.moderate %}
            $.html.addEventListenerAll('[x-forum-moderator-action="solve"]', 'click', function(e,elem) {
                let reason = prompt('{{ 'Grund'|trans({},'admin')|e('js') }}', '');
                if (reason !== null)
                    $.ajax.easySend('{{ path('forum_thread_mod_controller', {fid: fid, tid: tid, mod: 'solve'}) }}', {reason}, reloadPage);
            });
        {% endif %}

        $.html.addEventListenerAll('[x-forum-action="link-post"]', 'click', function(e,elem) {
            let link = document.getElementById('link-post-' + elem.getAttribute('x-post-id'));
            if (link.classList.contains('hidden')) link.classList.remove('hidden');
            else link.classList.add('hidden');
        });

        $.html.addEventListenerAll('[x-forum-action="report-post"]', 'click', function(e,elem) {
            let form = $.html.createElement('<div class="modal-form" id="modal-form" />');
            form.append($.html.createElement( '<p class="small bold"></p>', '{{ 'Bist du sicher, dass du diesen Post an die Moderatoren melden willst?'|trans({},'global')|e('js') }}' ));

            let sec_p = $.html.createElement('<p class="small"/>', '{{ 'Wenn möglich gib bitte einen Grund für deine Meldung an:'|trans({},'global')|e('js') }}');
            sec_p.append( $.html.createElement('<div><label><input checked type="radio" name="report_reason" value="0" />' + '{{ 'Keinen Grund angeben'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="1" />' + '{{ 'Cheating'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="2" />' + '{{ 'Flooding oder Spam'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="3" />' + '{{ 'Verwendung einer anderen als der Forensprache'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="4" />' + '{{ 'Beleidigungen / Unangemessener Ausdruck'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="5" />' + '{{ 'Pornographie'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="6" />' + '{{ 'Hassrede'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="7" />' + '{{ 'Verbreitung persönlicher Informationen'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="8" />' + '{{ 'Verletzung von Copyright'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="9" />' + '{{ 'Aufruf zu Gesetzesverstößen'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<div><label><input type="radio" name="report_reason" value="10" />' + '{{ 'Ermutigung von Selbstmord oder Selbstverletzung'|trans({},'global')|e('js') }}' + '</label></div>') )
            sec_p.append( $.html.createElement('<p class="small"/>', '{{ 'Zusätzliche Informationen zu deiner Meldung (optional):'|trans({},'global')|e('js') }}') )
            sec_p.append( $.html.createElement('<div><textarea maxlength="255" style="min-height: 70px; max-height: 120px; height: 70px;" name="report_details"></textarea></div>') )

            form.append(sec_p)

            $.html.popup('{{ 'Unangemessenen Inhalt melden'|trans({},'global')|e('js') }}', form, null, [
                [ '{{ 'Inhalt melden'|trans({},'global')|e('js') }}',  [ ['click', (e_sub, elem_sub) => {
                    const reason = document.querySelector('[name="report_reason"]:checked') ? parseInt(document.querySelector('[name="report_reason"]:checked').value) : 0;
                    const detail = document.querySelector('[name="report_details"]') ? document.querySelector('[name="report_details"]').value : '';
                    $.html.triggerPopupPop(elem_sub);
                    $.ajax.easySend( '{{ url('forum_report_post_controller', { 'fid': fid, 'tid': tid}) }}', {postId: parseInt( elem.getAttribute('x-post-id')), page: parseInt( elem.getAttribute('x-to-page')), reason: reason, details: detail }, reloadPage );
                }] ] ],
                [ '{{ 'Abbrechen'|trans({},'global')|e('js') }}', [ ['click', (e_sub, elem_sub) => $.html.triggerPopupPop(elem_sub)] ] ]
            ] );
        });

        {% if permission.moderate %}
            $.html.addEventListenerAll('[x-forum-moderator-action="move"]', 'click', function(e,elem) {
                elem.blur();
                let form = $.html.createElement('<div class="modal-form" id="modal-form" />');
                form.append($.html.createElement( '<p class="small bold"></p>', '{{ 'Verschiebe den aktuellen Thread in ein anderes Forum:'|trans({},'global')|e('js') }}' ));

                let select = $.html.createElement('<select/>');
                let group = null;
                {% for label, forum_group in thread_moveable_forums %}
                    group = $.html.createElement( '<optgroup label="{{ label }}"></optgroup>' )
                    {% for move_forum in forum_group|sort((a,b) => a.worldForumSorting <=> b.worldForumSorting) %}
                        group.append($.html.createElement( '<option value="{{ move_forum.id }}">{{ move_forum.title }}</option>' ) );
                    {% endfor %}
                    {% if forum_group is not empty %}
                        select.append(group );
                    {% endif %}
                {% endfor %}

                form.append(select)

                $.html.popup('{{ 'Thread verschieben'|trans({},'global')|e('js') }}', form, null, [
                    [ '{{ 'Verschieben'|trans({},'global')|e('js') }}',  [ ['click', (e_sub, elem_sub) => {
                        $.html.triggerPopupPop(elem_sub);
                        $.ajax.easySend( '{{ url('forum_thread_mod_controller', { 'fid': fid, 'tid': tid, 'mod': 'move'}) }}', {to: parseInt( select.value)}, reloadForumKeepPage );
                    }] ] ],
                    [ '{{ 'Abbrechen'|trans({},'global')|e('js') }}', [ ['click', (e_sub, elem_sub) => $.html.triggerPopupPop(elem_sub)] ] ]
                ] );
            });
        {% endif %}

        function get_forum_editor() {
            let editor = document.getElementById('forum-forum-editor');
            if (!editor) {
                editor = document.createElement('div');
                editor.setAttribute('id', 'forum-forum-editor');
                let anchor = document.getElementById('forum-editor-anchor');
                anchor.parentNode.insertBefore(editor, anchor);
            }
            return editor;
        }

        $.html.addEventListenerAll('[x-forum-action="quote-post"],[x-forum-action="copy-post"]', 'click', function(e,elem) {
            let editor = get_forum_editor();

            let fun_quote = function() {
                let content = document.querySelector('[x-post-content-id="' + elem.getAttribute('x-post-id') + '"]');
                let author = content.getAttribute('x-post-content-author');
                let author_id = parseInt(content.getAttribute('x-post-content-author-id'));
                let textEditor = document.getElementById("forum-forum-editor-text");
                const quote = elem.getAttribute('x-forum-action') === 'quote-post';

                if(textEditor.value !== '' && !textEditor.value.endsWith("\n")) textEditor.value += "\n";

                textEditor.value += (quote ? (author ? ('[quote=' + (author_id > 0 ? author.replace(/\W/, '') : author) + (author_id > 0 ? (':' + author_id) : '') + ']') : '[quote]') : '') + $.html.twinoParser.parseFrom( content.innerHTML, $.html.twinoParser.OpModeQuote ) + (quote ? '[/quote]' : '') + "\n";
                textEditor.dispatchEvent(new Event('input', {bubbles: true,cancelable: true}));
                textEditor.focus();
            };

            if (editor && editor.innerHTML === "") {
                $.ajax.no_history().load( get_forum_editor(), '{{ path('forum_post_editor_controller', {fid: fid, tid: tid}) }}', false, {}, fun_quote )
            } else fun_quote();
        });

        let fun_inline_edit = function(url, postID, twinoOpMode) {
            let editor = get_forum_editor();

            let fun_edit = function() {
                let content = document.querySelector('[x-post-content-id="' + postID + '"]');
                let textEditor = document.getElementById("forum-forum-editor-text");
                if (!textEditor) return;
                textEditor.value = $.html.twinoParser.parseFrom( content.innerHTML, twinoOpMode );
                textEditor.dispatchEvent(new Event('input', {bubbles: true,cancelable: true}));
                textEditor.focus();
            };

            let wrapper = document.querySelector('[x-post-wrapper-id="' + postID + '"]');
            if (wrapper && editor) wrapper.parentNode.insertBefore( editor, wrapper.nextSibling );

            $.html.forEach('[x-forum-action="answer"],[x-forum-action="sub"],[x-forum-action="unsub"]', e => e.classList.add('hidden'));

            if (editor) {
                editor.innerHTML = '';
                $.html.forEach( '[x-post-wrapper-id].hidden-by-editor', e => e.classList.remove('hidden','hidden-by-editor') )
                $.ajax.no_history().load( get_forum_editor(), url, false, {pid: postID},
                    () => {
                        if (wrapper) wrapper.classList.add('hidden','hidden-by-editor');
                        fun_edit();
                    });
            }
        }

        $.html.addEventListenerAll('[x-forum-action="edit-post"]', 'click', (e,elem) => fun_inline_edit('{{ path('forum_post_editor_controller', {fid: fid, tid: tid}) }}', elem.getAttribute('x-post-id'), 0));

        {% if permission.moderate() %}

            $.html.addEventListenerAll('.modrev.pointer', 'click', (e,elem) => { elem.classList.remove('pointer'); } )

            $.html.addEventListenerAll( '[x-forum-moderator-action="delete-post"]', 'click', function(e,elem) {
                let reason = prompt('{{ 'Grund'|trans({},'admin')|e('js') }}', '');
                if (reason !== null)
                    $.ajax.easySend( '{{ url('forum_thread_mod_controller', { 'fid': fid, 'tid': tid, mod: 'delete'}) }}', {reason: reason, postId: parseInt( elem.getAttribute('x-post-id')) }, reloadPage );
            } );
            $.html.addEventListenerAll( '[x-forum-moderator-action="undelete-post"]', 'click', function(e,elem) {
                $.ajax.easySend( '{{ url('forum_thread_mod_controller', { 'fid': fid, 'tid': tid, mod: 'undelete'}) }}', {postId: parseInt( elem.getAttribute('x-post-id')) }, reloadPage );
            } );
            $.html.addEventListenerAll( '[x-forum-moderator-action="seen"]', 'click', function(e,elem) {
                if (confirm("{{ 'Bestätigen?'|trans({},'global')|e('js') }}"))
                    $.ajax.easySend( '{{ url('forum_thread_mod_controller', { 'fid': fid, 'tid': tid, mod: 'seen'}) }}', {postId: parseInt( elem.getAttribute('x-post-id')) }, reloadPage );
            } );
            $.html.addEventListenerAll( '[x-forum-moderator-action="edit-post"]', 'click', function(e,elem) {
                fun_inline_edit('{{ path('forum_post_editor_controller', {fid: fid, tid: tid}) }}', elem.getAttribute('x-post-id'), $.html.twinoParser.OpModeRaw)
            } );
        {% endif %}
        $.html.addEventListenerAll( '[x-forum-moderator-action][x-forum-api-endpoint]', 'click', function(e,elem) {
            $.ajax.easySend( elem.getAttribute('x-forum-api-endpoint'), {}, reloadPage );
        } );

        $.html.addEventListenerAll( '.announces li', 'click', function(e,elem) {
            $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page:1, firstpost: elem.getAttribute('x-post-id') } );
        } );

        $.html.addEventListenerAll( '[x-forum-action="answer"]', 'click', function(e,elem) {
            $.html.forEach('[x-forum-action="answer"],[x-forum-action="sub"],[x-forum-action="unsub"]', e => e.remove());
            $.ajax.no_history().load( get_forum_editor(), '{{ path('forum_post_editor_controller', {fid: fid, tid: tid}) }}', false, {}, function() {
                get_forum_editor().scrollIntoView();
                document.getElementById("forum-forum-editor-text").focus();
            } );
        } );

        $.html.addEventListenerAll( '[x-forum-action="sub"]', 'click', function(e,elem) {
            $.ajax.easySend( '{{ path('forum_thread_subscribe_controller', {fid: fid, tid: tid})|e('js') }}', {}, reloadPage );
        } );
        $.html.addEventListenerAll( '[x-forum-action="unsub"]', 'click', function(e,elem) {
            $.ajax.easySend( '{{ path('forum_thread_unsubscribe_controller', {fid: fid, tid: tid})|e('js') }}', {}, reloadPage );
        } );

        $.html.addEventListenerAll( '[x-forum-action="post-pager"][x-to-page]', 'click', function(e,elem) {
            let editor = get_forum_editor();
            {% if editor is defined %}
                {let c; while ((c = editor.firstChild)) editor.removeChild(c);}
            {% endif %}
            const from_page = {{ current_page|e('js') }};
            const to_page = parseInt( elem.getAttribute('x-to-page') );
            $.ajax.push_history('{{ path('forum_thread_view', {fid: fid, tid: tid}) }}/' + to_page);
            $.html.forEach('.forum-reload-button', e => e.setAttribute('x-ajax-href', '{{ path('forum_thread_view', {fid: fid, tid: tid}) }}/' + to_page));

            $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page: to_page},
                function() {
                    let scrollTo = null;
                    if (from_page > to_page)      scrollTo = document.querySelector('#pagenav-bottom');
                    else if (from_page < to_page) scrollTo = document.querySelector('#pagenav-top');
                    if (scrollTo) scrollTo.scrollIntoView();
                }
            );
        } );

        $.html.addEventListenerAll( '[x-forum-action="post-select-page"]', 'click', function(e,elem) {
            e.preventDefault();
            e.stopPropagation();
            let pagMarker = elem.querySelector(".current_page_marker");
            pagMarker.innerHTML = '<input type="text" name="page_to_go" class="page_to_go inline" style="width: 24px;margin: 0 5px" />';
            elem.querySelector("input.page_to_go").focus();
            $.html.addEventListenerAll('[x-forum-action="post-select-page"] input.page_to_go', 'click', function(e, elem){
                e.preventDefault();
                e.stopPropagation();
            });
            $.html.addEventListenerAll('[x-forum-action="post-select-page"] input.page_to_go', 'change', function(e, elem){
                let editor = get_forum_editor();
                {% if editor is defined %}
                {let c; while ((c = editor.firstChild)) editor.removeChild(c);}
                {% endif %}
                let to_page = parseInt( elem.value );
                if (isNaN(to_page))
                    return;
                if (to_page > {{ pages }})
                    to_page = {{ pages }};
                if (to_page < 1) to_page = 1;
                $.ajax.push_history('{{ path('forum_thread_view', {fid: fid, tid: tid}) }}/' + to_page);
                $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('forum_viewer_controller', {fid: fid, tid: tid}) }}', false, {page: to_page});
            });
        } );

        $.html.addEventListenerAll('[x-forum-action="post-select-page"]', 'focusout', function(e, elem){
            elem.innerHTML = '{{ 'Seite {page}/{pages}'|trans({'{page}': '<span class="current_page_marker">&nbsp;' ~ current_page ~ '</span>', '{pages}': pages},'global')|raw }}';
        });

        {% if pages == current_page %}
            $.html.forEach( '[x-thread-id="{{ tid }}"]', e => e.classList.remove('forum-thread-unread') );
        {% endif %}

        {% if markedPost is defined and markedPost > 0 %}
            const selected_post = document.querySelector('[x-post-wrapper-id="{{markedPost}}"]');
            if (selected_post) selected_post.scrollIntoView();
        {% endif %}

        let polls = [];
        $.html.forEach('.forum-post-content ul.poll[x-poll-id]', element => {
            const poll_id = parseInt(element.getAttribute('x-poll-id'), 10);
            if (!poll_id || isNaN(poll_id) || poll_id < 0) element.innerHTML += '<li class="plain"><strong style="color: red">{{ 'Diese Umfrage ist ungültig oder wurde gelöscht.'|trans({},'global')|e('js') }}</strong></li>';
            else polls.push(poll_id);
        });

        if (polls.length > 0)
            $.ajax.background().easySend( '{{ path('forum_poll_query_api', {fid: fid, tid: tid}) }}', {polls: polls},
                function (data) {
                    const database = data.response ? data.response : [];
                    polls.forEach(key => {
                        if (typeof database[key] === "undefined" || database[key] === false) document.querySelector('.forum-post-content ul.poll[x-poll-id="' + key + '"]').innerHTML += '<li class="plain"><strong style="color: red">{{ 'Diese Umfrage ist ungültig oder wurde gelöscht.'|trans({},'global')|e('js') }}</strong></li>';
                        else if (database[key] === true) {
                            $.html.forEach('.forum-post-content ul.poll[x-poll-id="' + key + '"]>li[x-poll-id="' + key + '"][x-answer-id]', element => {
                               let button = $.html.createElement('<button class="small inline" />', '{{ 'Abstimmen'|trans({},'global') }}');
                               button.addEventListener('click',() => {
                                   $.ajax.easySend( '{{ path('forum_poll_cast_api', {fid: fid, tid: tid}) }}', {poll: key, cast: parseInt(element.getAttribute('x-answer-id'))}, reloadPage);
                               });
                               let structure = $.html.createElement('<div class="row-flex wrap"><div class="cell grow-1"></div><div class="cell shrink-1"></div>');
                               while (element.firstChild) structure.firstChild.appendChild(element.firstChild);
                               structure.lastChild.appendChild( button );
                               element.appendChild(structure);
                            });
                            let button = $.html.createElement('<button class="small inline" />', '{{ 'Ergebnisse anzeigen'|trans({},'global') }}');
                            button.addEventListener('click',() => {
                                if (confirm('{{ 'Wenn du die Ergebnisse abrufst kannst du danach nicht mehr abstimmen. Bist du sicher?'|trans({},'global') }}'))
                                    $.ajax.easySend( '{{ path('forum_poll_cast_api', {fid: fid, tid: tid}) }}', {poll: key, cast: -42}, reloadPage);
                            });
                            let structure = $.html.createElement('<li class="plain right" />');
                            structure.appendChild(button);
                            document.querySelector('.forum-post-content ul.poll[x-poll-id="' + key + '"]').appendChild(structure);
                        } else {
                            let total = 0; let can_close = false;
                            database[key].forEach(answer => {
                                if (answer[0] > 0) total += answer[1];
                                else if (answer[0] === -666) can_close = answer[1];
                            });
                            database[key].forEach(answer => {
                                if (answer[0] <= 0) return;
                                let answer_object = document.querySelector('.forum-post-content ul.poll[x-poll-id="' + key + '"]>li[x-poll-id="' + key + '"][x-answer-id="' + answer[0] + '"]')
                                if (answer_object) {
                                    let structure = $.html.createElement('<div class="row-flex wrap"><div class="cell grow-1"></div><div class="cell rw-3 rw-lg-4 rw-sm-12 shrink-0"></div>');
                                    while (answer_object.firstChild) structure.firstChild.appendChild(answer_object.firstChild);
                                    let process = $.html.createElement('<div class="vote-bar"><div class="bar"></div></div>');
                                    process.firstChild.style.width = total > 0 ? ((100*answer[1]/total)+'%') : '0%';
                                    structure.lastChild.appendChild( $.html.createElement('<div class="right"><strong>' + answer[1] + '</strong></div>') );
                                    structure.lastChild.appendChild( process );
                                    answer_object.appendChild(structure);
                                }
                            });

                            if (can_close) {
                                let button = $.html.createElement('<button class="small inline" />', '{{ 'Umfrage schließen'|trans({},'global') }}');
                                button.addEventListener('click',() => {
                                    if (confirm('{{ 'Diese Aktion kann nicht rückgängig gemacht werden. Bist du sicher?'|trans({},'global') }}'))
                                        $.ajax.easySend( '{{ path('forum_poll_cast_api', {fid: fid, tid: tid}) }}', {poll: key, cast: -666}, reloadPage);
                                });
                                let structure = $.html.createElement('<li class="plain right" />');
                                structure.appendChild(button);
                                document.querySelector('.forum-post-content ul.poll[x-poll-id="' + key + '"]').appendChild(structure);
                            }
                        }
                    });
                } );

    </script>
{% endblock %}
